Index: WorldVistAEHR/trunk/r/KERNEL-XU-A4A7-USC-XG-XLF-XNOA-XPD-XQ-XVIR-ZI-ZOSF-ZOSV-ZT-ZU-%Z-XIP--XQAB--XUC--XUR--ZIN--ZTED/_ZIS3.m
===================================================================
--- WorldVistAEHR/trunk/r/KERNEL-XU-A4A7-USC-XG-XLF-XNOA-XPD-XQ-XVIR-ZI-ZOSF-ZOSV-ZT-ZU-%Z-XIP--XQAB--XUC--XUR--ZIN--ZTED/_ZIS3.m	(revision 613)
+++ WorldVistAEHR/trunk/r/KERNEL-XU-A4A7-USC-XG-XLF-XNOA-XPD-XQ-XVIR-ZI-ZOSF-ZOSV-ZT-ZU-%Z-XIP--XQAB--XUC--XUR--ZIN--ZTED/_ZIS3.m	(revision 623)
@@ -1,82 +1,71 @@
-%ZIS3	;SFISC/AC,RWF -- DEVICE HANDLER(DEVICE TYPES & PARAMETERS) ;1/24/08  13:18
-	;;8.0;KERNEL;**18,36,69,104,391,440**;JUL 10, 1995;Build 13
-	;Per VHA Directive 2004-038, this routine should not be modified
-	;Call with a Go from ^%ZIS2
-	I %ZIS'["T",$G(^%ZIS(1,+%E,"POX"))]"" D XPOX^ZISX(%E) ;Pre-Open
-	I $D(%ZISQUIT) S POP=1 K %ZISQUIT
-	S %ZISCHK=1
-	;I 'POP&(%ZISB)&(%ZTYPE'="RES")&(%ZTYPE'="OTH")&(%ZTYPE'="SDP")&(IO'["::") D DEVOK
-	;See if need to lock.
-	K %ZISLOCK
-	I %ZIS'["T",+$G(^%ZIS(1,+%E,"GBL")) S %ZISLOCK=$NA(^%ZIS("lock",IO))
-	;
-	I 'POP G TRM:(%ZTYPE["TRM"),@(%ZTYPE_"^%ZIS6") ;Jump to next part
-	;
-Q	;%ZIS6 Returns here
-	;See if need to un-lock.
-	I $D(%ZISUOUT) K %ZISUOUT,%ZISHP,%ZISHPOP Q
-	I $D(%ZISHPOP)&$S(IO="":1,1:'$D(IO(1,IO))) D HGBSY^%ZIS2 Q
-	I POP S:%ZIS'["T" IO="" I $D(%ZISHG(0)),%ZIS'["D",'$D(%ZISHPOP) G HUNT^%ZIS2
-	Q  ;Return to %ZIS1
-	;
-VTRM	;Virtual terminal type
-TRM	;D OPEN^%ZIS4:'POP&(%ZISB&(%ZIS'["T")),MARGN:'POP,SETPAR:'POP ;Terminal type
-	D MARGN:'POP,SETPAR:'POP ;Terminal type// TEST CHANGE
-	I 'POP,%ZIS'["T",%ZISB=1,'$D(IOP),IO'=IO(0),'$D(IO("Q")),%ZIS["Q" D AQUE
-	W:'$D(IOP) !
-	I '$D(IO("Q")),'POP,%ZISB,%ZIS'["T" D O^%ZIS4
-	G Q
-DEVOK	N X,Y,X1 ;Not sure this is needed
-	S X=IO,X1=%ZTYPE
-	D DEVOK^%ZOSV I Y=-99!(Y=0)!(Y=$J) Q
-	I Y>0 S POP=1 W:'$D(IOP)&('$D(%ZISHG(0))!(%IS["D")) !,$C(7),"[Device Unavailable]" Q
-	I Y=-1 S IO="",POP=1 W:'$D(IOP)&('$D(ZISHG(0))!(%IS["D")) !,$C(7),"[Device does not Exist or Unavailable]" Q
-	Q
-	;
-MARGN	;Get the margin and page length
-	S %A=$P(%Y,";",1)
-	I %A?1A.ANP D SUBIEN(.%A,1) I $D(^%ZIS(2,%A,1)) K %Z91 D ST(1) S %Y=$P(%Y,";",2,9),%ZISMY=$P(%ZISMY,";",2,9) G MARGN
-	I %A>3 S $P(%Z91,"^")=$S(%A>255:255,1:+%A)
-	I $P(%Y,";",2) S $P(%Z91,"^",3)=+$S($P(%Y,";",2)>65530:65530,1:$P(%Y,";",2)) ;Cache fix for $Y#65535 wrap
-	;
-ALTP	I '$D(IO("P")) Q:%A>3  G ASKMAR:%ZTYPE["TRM" Q
-	S %X=$F(IO("P"),"M") I %X S %A=+$E(IO("P"),%X,99),$P(%Z91,"^")=$S(%A>255:255,1:%A)
-	S %X=$F(IO("P"),"L") I %X S $P(%Z91,"^",3)=+$E(IO("P"),%X,99)
-	Q:%A>3!(%ZTYPE'["TRM")
-ASKMAR	I %IS["M",'$D(IOP),$S(%E=%H:+$P(%Z,"^",3),1:1),$P(%Z,"^",4) W "    Right Margin: " W:$P(%Z91,"^")]"" +%Z91,"// "
-	E  Q
-	D SBR^%ZIS1 I '$D(DTOUT)&'$D(DUOUT) S:%X=""&($P(%Z91,"^")]"") %X=+%Z91 G ASKMAR:%X'?1.N S $P(%Z91,"^")=$S(%X>255:255,1:%X) Q
-	S POP=1 I %ZISB&(%ZTYPE["TRM")&(IO'=IO(0)) C IO K IO(1,IO) Q
-	Q
-SETPAR	S:$L(%ZISOPAR)&($E(%ZISOPAR)'="(") %ZISOPAR="("_%ZISOPAR_")"
-	Q
-AQUE	;Ask about Queueing
-	W ! S %=$S($D(IO("Q")):1,1:2),U="^",%ZISDTIM=60
-	I $D(IO("Q")) W !,"Previously, you have selected queueing."
-	W !,"Do you "_$S($D(IO("Q")):"STILL ",1:"")_"want your output QUEUED"
-	D YN^%ZIS1 K %ZISDTIM G AQUE:%=0 Q:$D(IO("Q"))
-	I %=-1 S POP=1,%ZISHPOP=1,%ZISUOUT=1 C IO K IO(1,IO) Q
-	I %=1 S IO("Q")=1 C IO K IO(1,IO) Q
-	;I %=2 K IO("Q")
-	Q
-ST(%ZISTP)	;
-	S %ZISIOST(0)=%A,%ZISIOST=$P($G(^%ZIS(2,%A,0)),"^")
-	S:'$D(%Z91) %Z91=$P($G(^%ZIS(2,%A,1),"132^#^60^$C(8)"),"^",1,4),$P(%Z91,"^",5)=$G(^("XY"))
-	Q:%ZISTP
-STP	N %B ;%E is a pointer to the Device file
-	S %B=$G(^%ZIS(1,%E,91))
-	S:$P(%B,"^")]"" $P(%Z91,"^")=+%B S:$P(%B,"^",3)]"" $P(%Z91,"^",3)=$P(%B,"^",3) ;S $P(%Z91,"^",5)=$G(^%ZIS(2,%ZISIOST(0),"XY"))
-	Q
-SUBIEN(%1,%)	;Return Subtype ien. %1 is call by Ref.
-	N %XX,%YY
-	I $D(^%ZIS(2,"B",%1))>9 S %1=+$O(^%ZIS(2,"B",%1,0)) Q
-	I '$G(%) S X="" Q
-	S %XX=%1 D 2^%ZIS5 S %1=+%YY
-	Q
-SUBTYPE(%A)	;Called from %ZISH
-	N %ZISIOST,%Z91
-	S:$G(%A)="" %A="P-OTHER"
-	D SUBIEN(.%A),ST(1)
-	S IOM=$P(%Z91,U,1),IOF=$P(%Z91,U,2),IOSL=$P(%Z91,U,3),IOST=%ZISIOST,IOST(0)=%ZISIOST(0),IOBS="$C(8)"
-	S:IOST="" IOST="P-OTHER",IOST(0)=0
-	Q
+%ZIS3 ;SFISC/AC,RWF -- DEVICE HANDLER(DEVICE TYPES & PARAMETERS) ;10/06/2005  13:23
+ ;;8.0;KERNEL;**18,36,69,104,391**;JUL 10, 1995
+ I %ZIS'["T",$G(^%ZIS(1,+%E,"POX"))]"" D XPOX^ZISX(%E)
+ I $D(%ZISQUIT) S POP=1 K %ZISQUIT
+ S %ZISCHK=1
+ I 'POP&(%ZISB)&(%ZTYPE'="RES")&(%ZTYPE'="OTH")&(%ZTYPE'="SDP")&(IO'["::") D DEVOK
+ G Q:POP
+ G @%ZTYPE:(%ZTYPE["TRM"),@(%ZTYPE_"^%ZIS6") ;Jump to next part
+ ; 
+Q I $D(%ZISUOUT) K %ZISUOUT,%ZISHP,%ZISHPOP Q
+ I $D(%ZISHPOP)&$S(IO="":1,1:'$D(IO(1,IO))) D HGBSY^%ZIS2 Q
+ I POP S:%IS'["T" IO="" I $D(%ZISHG(0)),%IS'["D",'$D(%ZISHPOP) G HUNT^%ZIS2
+ Q
+VTRM ;Virtual terminal type
+TRM D OPEN^%ZIS4:'POP&(%ZISB&(%IS'["T")),MARGN:'POP,SETPAR:'POP ;Terminal type
+ I 'POP,%IS'["T",%ZISB=1,'$D(IOP),IO'=IO(0),'$D(IO("Q")),%IS["Q" D AQUE
+ W:'$D(IOP) ! I '$D(IO("Q")) D O^%ZIS4:'POP&(%ZISB&(%IS'["T"))
+ G Q
+DEVOK N X,Y,X1
+ S X=IO,X1=%ZTYPE
+ D DEVOK^%ZOSV I Y=-99!(Y=0)!(Y=$J) Q
+ I Y>0 S POP=1 W:'$D(IOP)&('$D(%ZISHG(0))!(%IS["D")) !,*7,"[Device Unavailable]" Q
+ I Y=-1 S IO="",POP=1 W:'$D(IOP)&('$D(ZISHG(0))!(%IS["D")) !,*7,"[Device does not Exist or Unavailable]" Q
+ Q
+ ;
+MARGN ;Get the margin and page length
+ S %A=$P(%Y,";",1)
+ I %A?1A.ANP D SUBIEN(.%A,1) I $D(^%ZIS(2,%A,1)) K %Z91 D ST(1) S %Y=$P(%Y,";",2,9),%ZISMY=$P(%ZISMY,";",2,9) G MARGN
+ I %A>3 S $P(%Z91,"^")=$S(%A>255:255,1:+%A)
+ I $P(%Y,";",2) S $P(%Z91,"^",3)=+$S($P(%Y,";",2)>65530:65530,1:$P(%Y,";",2)) ;Cache fix for $Y#65535 wrap
+ ;
+ALTP I '$D(IO("P")) Q:%A>3  G ASKMAR:%ZTYPE["TRM" Q
+ S %X=$F(IO("P"),"M") I %X S %A=+$E(IO("P"),%X,99),$P(%Z91,"^")=$S(%A>255:255,1:%A)
+ S %X=$F(IO("P"),"L") I %X S $P(%Z91,"^",3)=+$E(IO("P"),%X,99)
+ Q:%A>3!(%ZTYPE'["TRM")
+ASKMAR I %IS["M",'$D(IOP),$S(%E=%H:+$P(%Z,"^",3),1:1),$P(%Z,"^",4) W "    Right Margin: " W:$P(%Z91,"^")]"" +%Z91,"// "
+ E  Q
+ D SBR^%ZIS1 I '$D(DTOUT)&'$D(DUOUT) S:%X=""&($P(%Z91,"^")]"") %X=+%Z91 G ASKMAR:%X'?1.N S $P(%Z91,"^")=$S(%X>255:255,1:%X) Q
+ S POP=1 I %ZISB&(%ZTYPE["TRM")&(IO'=IO(0)) C IO K IO(1,IO) Q
+ Q
+SETPAR S:%ZISOPAR]""&($A(%ZISOPAR)-40) %ZISOPAR="("_%ZISOPAR_")"
+ Q
+AQUE W ! S %=$S($D(IO("Q")):1,1:2),U="^",%ZISDTIM=60
+ I $D(IO("Q")) W !,"Previously, you have selected queueing."
+ W !,"Do you "_$S($D(IO("Q")):"STILL ",1:"")_"want your output QUEUED"
+ D YN^%ZIS1 K %ZISDTIM G AQUE:%=0 Q:$D(IO("Q"))
+ I %=-1 S POP=1,%ZISHPOP=1,%ZISUOUT=1 C IO K IO(1,IO) Q
+ I %=1 S IO("Q")=1 C IO K IO(1,IO) Q
+ Q
+ST(%ZISTP) ;
+ S %ZISIOST(0)=%A,%ZISIOST=$P($G(^%ZIS(2,%A,0)),"^")
+ S:'$D(%Z91) %Z91=$P($G(^%ZIS(2,%A,1),"132^#^60^$C(8)"),"^",1,4),$P(%Z91,"^",5)=$G(^("XY"))
+ Q:%ZISTP
+STP N %B ;%E is a pointer to the Device file
+ S %B=$G(^%ZIS(1,%E,91))
+ S:$P(%B,"^")]"" $P(%Z91,"^")=+%B S:$P(%B,"^",3)]"" $P(%Z91,"^",3)=$P(%B,"^",3) ;S $P(%Z91,"^",5)=$G(^%ZIS(2,%ZISIOST(0),"XY"))
+ Q
+SUBIEN(%1,%) ;Return Subtype ien. %1 is call by Ref.
+ N %XX,%YY
+ I $D(^%ZIS(2,"B",%1))>9 S %1=+$O(^%ZIS(2,"B",%1,0)) Q
+ I '$G(%) S X="" Q
+ S %XX=%1 D 2^%ZIS5 S %1=+%YY
+ Q
+SUBTYPE(%A) ;Called from %ZISH
+ N %ZISIOST,%Z91
+ S:$G(%A)="" %A="P-OTHER"
+ D SUBIEN(.%A),ST(1)
+ S IOM=$P(%Z91,U,1),IOF=$P(%Z91,U,2),IOSL=$P(%Z91,U,3),IOST=%ZISIOST,IOST(0)=%ZISIOST(0),IOBS="$C(8)"
+ S:IOST="" IOST="P-OTHER",IOST(0)=0
+ Q
+ 
Index: WorldVistAEHR/trunk/r/KERNEL-XU-A4A7-USC-XG-XLF-XNOA-XPD-XQ-XVIR-ZI-ZOSF-ZOSV-ZT-ZU-%Z-XIP--XQAB--XUC--XUR--ZIN--ZTED/_ZIS4.m
===================================================================
--- WorldVistAEHR/trunk/r/KERNEL-XU-A4A7-USC-XG-XLF-XNOA-XPD-XQ-XVIR-ZI-ZOSF-ZOSV-ZT-ZU-%Z-XIP--XQAB--XUC--XUR--ZIN--ZTED/_ZIS4.m	(revision 613)
+++ WorldVistAEHR/trunk/r/KERNEL-XU-A4A7-USC-XG-XLF-XNOA-XPD-XQ-XVIR-ZI-ZOSF-ZOSV-ZT-ZU-%Z-XIP--XQAB--XUC--XUR--ZIN--ZTED/_ZIS4.m	(revision 623)
@@ -1,109 +1,103 @@
-%ZIS4	;ISF/RWF,DW - DEVICE HANDLER SPECIFIC CODE (GT.M for Unix/VMS) ;1/24/08  16:08
-	;;8.0;KERNEL;**275,425,440**;Jul 10, 1995;Build 13
-	;Per VHA Directive 2004-038, this routine should not be modified
-OPEN	;From %ZIS3 for TRM
-	G OPN2:$D(IO(1,IO))
-	S POP=0 D OP1 G NOPEN:'$D(IO(1,IO))
-OPN2	;
-	I $D(%ZISHP),'$D(IOP) W !,*7," Routing to device "_$P(^%ZIS(1,%E,0),"^",1)_$S($D(^(1)):" "_$P(^(1),"^",1)_" ",1:"")
-	Q
-NOPEN	I %IS'["D",$D(%ZISHP)!(%ZISHG]"") S POP=1 Q
-	I '$D(IOP) W *7,"  [BUSY]" W "  ...  RETRY" S %=2,U="^" D YN^%ZIS1 G OPEN:%=1
-	S POP=1 Q
-	Q
-	;Why no open paraneters???
-OP1	N $ET S $ET="G OPNERR^%ZIS4"
-	I $D(%ZISLOCK) L +@%ZISLOCK:5 E  S POP=1 Q
-	O IO::%ZISTO S:$T IO(1,IO)="" S:'$T POP=1
-	Q
-OPNERR	;Open Error
-	S POP=1,IO("LASTERR")=$G(IO("ERROR")),IO("ERROR")=$$EC^%ZOSV,$EC=""
-	Q
-	;
-O	;From %ZIS6 for all types.
-	D:%IS["L" ZIO
-	I $D(IO("S")),$D(^%ZIS(2,IO("S"),10)),^(10)]"" U IO(0) D X10^ZISX ;Open Printer Port
-OPAR	I $D(IOP),%ZTYPE="HFS",$D(%IS("HFSIO")),$D(%IS("IOPAR")),%IS("HFSIO")]"" S IO=%IS("HFSIO"),%ZISOPAR=%IS("IOPAR")
-	I %ZTYPE="CHAN" D TCPIP Q:POP  G OXECUTE^%ZIS6
-	S %A=%ZISOPAR_$S(%ZISOPAR["):":"",1:":"_%ZISTO)
-	N % S %(IO)="",%=$P($P($NA(%(IO)),"(",2),")")
-	S %A=%_$E(":",%A]"")_%A
-	D O1 I POP D  Q
-	.I %ZTYPE="HFS",'$D(IOP),$G(IO("ERROR"))["file not found" W !,?5,*7,"[File Not Found]" Q
-	.W:'$D(IOP) !,?5,*7,"[DEVICE IS BUSY]" Q
-	;S IO(1,IO)="" U IO S:'(IO=IO(0)&'$D(IO("S"))&'$D(ZTQUEUED)) $X=0,$Y=0 I %ZTYPE["TRM" U IO:(WIDTH=+%Z91)
-	U IO S $X=0,$Y=0 I %ZTYPE["TRM" U IO:(WIDTH=+%Z91)
-	I %ZISUPAR]"" S %A1=""""_IO_""":"_%ZISUPAR U @%A1
-	;U:%IS'[0 IO(0)
-	G OXECUTE^%ZIS6
-	;
-O1	N $ES,$ET S $ET="G OPNERR^%ZIS4"
-	I $D(%ZISLOCK) L +@%ZISLOCK:5 E  S POP=1 Q
-	O @%A S:'$T&(%A?.E1":".N) POP=1 S:'POP IO(1,IO)=""
-	S IO("ERROR")="" Q
-	;
-	;Need to find out how to get IP address
-ZIO	N %,%1 S (%,%1)=$ZIO
-	I $ZV["VMS",%["_TNA" D
-	. S (%,%1)=$ZGETDVI($I,"TT_ACCPORNAM")
-	. S %=$S(%["Host:":$P($P(%,"Host: ",2)," ")_":"_$P(%,"Port: ",2),1:%) S:%[" " %=$TR(%," ")
-	I $ZV'["VMS" D
-	. S (%,%1)=$ZTRNLNM("REMOTEHOST") S:$L(%) %1="Host:"_% S:'$L(%) %=$ZIO
-	S IO("ZIO")=% S:(%1["Host:")&'$D(IO("IP")) IO("IP")=$P(%,":")
-	Q
-	;
-TCPIP	;For TCP/IP devices, should use ^%ZISTCP
-	N %S
-	S %ZISTO=$G(%ZISTO,3)
-	S %A="IO:"_$S($E(%ZISOPAR)="(":"",1:"(")_%ZISOPAR_$S($E(%ZISOPAR,$L(%ZISOPAR))=")":"",1:")")_":%ZISTO:""SOCKET"""
-	;U $P W !,"%A=",%A
-	O @%A I '$T S POP=1 Q  ;D O1 ;Do the open.
-	U IO:(WIDTH=512:NOWRAP:EXCEPT="G OPNERR^%ZIS4") S %S=$KEY
-	U $P ;W !,"$KEY=",%S
-	Q
-	;
-SPOOL	;%ZDA=pointer to ^XMB(3.51, %ZFN=spool file name.
-	I $D(ZISDA) W:'$D(IOP) !?5,*7,"You may not Spool the printing of a Spool document" G N
-	I $D(DUZ)[0 W:'$D(IOP) !,"Must be a valid user." G N
-R	S %ZY=-1 D NEWDOC^ZISPL1 G N:%ZY'>0
-	S %ZDA=+%ZY,%ZFN=$P(%ZY(0),U,2),IO("DOC")=$P(%ZY(0),U,1) G OK:$D(IO("Q"))
-	G:'%ZISB OK I '$P(%ZY,"^",3),$L(%ZFN) O %ZFN:(append:nowrap):2 G DOC
-	S %ZFN=IO_"SPOOL_no_"_%ZDA_".TMP" D SPL2 G:%ZFN']"" N S $P(^XMB(3.51,%ZDA,0),U,2)=%ZFN,^XMB(3.51,"C",%ZFN,%ZDA)=""
-DOC	S IO=%ZFN,IO("SPOOL")=%ZDA,^XUTL("XQ",$J,"SPOOL")=%ZDA,IOF="#"
-	I $D(^%ZIS(1,%ZISIOS,1)),$P(^(1),"^",8),$O(^("SPL",0)) S ^XUTL("XQ",$J,"ADSPL")=%ZISIOS,ZISPLAD=%ZISIOS
-OK	K %ZDA,%ZFN Q
-N	K %ZDA,%ZFN,IO("DOC") S POP=1 Q
-	;
-SPL2	;Open for write
-	O %ZFN:(newversion:noreadonly:nowrap:exception="G SPL4"):2 G:$ZA<0 SPL4 S IO(1,%ZFN)="" Q
-	;
-SPL3	;Open for Read
-	O %ZFN:(readonly:exception="G SPL4"):2 S:'$T ZISPLQ=1 G:'$T SPL4 S IO(1,%ZFN)="" Q
-SPL4	W:'$D(IOP)&'$D(ZTQUEUED) !?5,*7,"Couldn't open the spool file." S %ZFN="" Q
-	;
-CLOSE	;Close out the spool
-	N %,%1,%Z1,%ZFN,%ZS,%ZDA,XS,%Y,%X
-	I $L(IO) C IO K IO(1,IO)
-	D FILE^ZISPL1 I %ZDA'>0 K ZISPLAD Q
-	S %ZFN=$P(%ZS,"^",2) D SPL3 Q:%ZFN']""  S %ZCR=$C(13),%Y=""
-	S %Z1=+$G(^XTV(8989.3,1,"SPL")),%=0
-	U %ZFN F  R %X#255:5 Q:$ZEOF  S %2=%X D CL2 Q:%Z1<%
-SPLEX	C %ZFN:(DELETE) K:%ZFN]"" IO(1,%ZFN) D CLOSE^ZISPL1 K %Y,%X,%1,%ZFN Q
-	;
-CL2	S %=%+1 I %Z1<% S ^XMBS(3.519,XS,2,%,0)="*** INCOMPLETE REPORT  -- SPOOL DOCUMENT LINE LIMIT EXCEEDED ***",$P(^XMB(3.51,%ZDA,0),"^",11)=1 Q
-	I %2[$C(12) S ^XMBS(3.519,XS,2,%,0)="|TOP|" Q
-	S ^XMBS(3.519,XS,2,%,0)=%2 Q
-	;
-HFS	G HFS^%ZISF
-REWMT(IO,IOPAR)	;Rewind Magtape
-	S X="REWERR^%ZIS4",@^%ZOSF("TRAP")
-	U IO W *5
-	Q 1
-REWSDP(IO,IOPAR)	;Rewind SDP
-	G REW1
-REWHFS(IO,IOPAR)	;Rewind Host File.
-REW1	S X="REWERR^%ZIS4",@^%ZOSF("TRAP")
-	U IO:(REWIND)
-	Q 1
-REWERR	;Error encountered
-	Q 0
+%ZIS4 ;ISF/RWF,DW - DEVICE HANDLER SPECIFIC CODE (GT.M for Unix/VMS) ;03/07/2007
+ ;;8.0;KERNEL;**275,425**;Jul 10, 1995;Build 18
+ ;
+OPEN ;From %ZIS3 for TRM
+ G OPN2:$D(IO(1,IO))
+ S POP=0 D OP1 G NOPEN:'$D(IO(1,IO))
+OPN2 ;
+ I $D(%ZISHP),'$D(IOP) W !,*7," Routing to device "_$P(^%ZIS(1,%E,0),"^",1)_$S($D(^(1)):" "_$P(^(1),"^",1)_" ",1:"")
+ Q
+NOPEN I %IS'["D",$D(%ZISHP)!(%ZISHG]"") S POP=1 Q
+ I '$D(IOP) W *7,"  [BUSY]" W "  ...  RETRY" S %=2,U="^" D YN^%ZIS1 G OPEN:%=1
+ S POP=1 Q
+ Q
+ ;Why no open paraneters???
+OP1 N $ES,$ET S $ET="G OPNERR^%ZIS4"
+ L:$D(%ZISLOCK) +@%ZISLOCK:60
+ O IO::%ZISTO S:$T IO(1,IO)="" S:'$T POP=1 L:$D(%ZISLOCK) -@%ZISLOCK
+ Q
+OPNERR ;Open Error
+ S POP=1,IO("LASTERR")=$G(IO("ERROR")),IO("ERROR")=$$EC^%ZOSV,$EC="" Q
+ ;
+O ;From %ZIS6 for other types.
+ D:%IS["L" ZIO
+LCKGBL ;Lock Global
+ I %ZTYPE="CHAN" N % S %=$G(^%ZIS(1,+%E,"GBL")) I $L(%) L @("+^"_%_":0") S:'$T POP=1 I POP W:'$D(IOP) !,?5,*7,"[DEVICE IS BUSY]" Q
+ I $D(IO("S")),$D(^%ZIS(2,IO("S"),10)),^(10)]"" U IO(0) D X10^ZISX
+OPAR I $D(IOP),%ZTYPE="HFS",$D(%IS("HFSIO")),$D(%IS("IOPAR")),%IS("HFSIO")]"" S IO=%IS("HFSIO"),%ZISOPAR=%IS("IOPAR")
+ I %ZTYPE="CHAN" D TCPIP Q:POP  G OXECUTE^%ZIS6
+ S %A=%ZISOPAR_$S(%ZISOPAR["):":"",%ZTYPE["CHAN"&($P(%ZTIME,"^",3)="n"):"",1:":"_%ZISTO)
+ N % S %(IO)="",%=$P($P($NA(%(IO)),"(",2),")")
+ S %A=%_$E(":",%A]"")_%A
+ D O1 I POP D  Q
+ .I %ZTYPE="HFS",'$D(IOP),$G(IO("ERROR"))["file not found" W !,?5,*7,"[File Not Found]" Q
+ .W:'$D(IOP) !,?5,*7,"[DEVICE IS BUSY]" Q
+ ;S IO(1,IO)="" U IO S:'(IO=IO(0)&'$D(IO("S"))&'$D(ZTQUEUED)) $X=0,$Y=0 I %ZTYPE["TRM" U IO:(WIDTH=+%Z91)
+ U IO S $X=0,$Y=0 I %ZTYPE["TRM" U IO:(WIDTH=+%Z91)
+ I %ZISUPAR]"" S %A1=""""_IO_""":"_%ZISUPAR U @%A1
+ ;U:%IS'[0 IO(0)
+ G OXECUTE^%ZIS6
+ ;
+O1 N $ES,$ET S $ET="G OPNERR^%ZIS4"
+ L:$D(%ZISLOCK) +@%ZISLOCK:60
+ O @%A S:'$T&(%A?.E1":".N) POP=1 S:'POP IO(1,IO)="" L:$D(%ZISLOCK) -@%ZISLOCK
+ S IO("ERROR")="" Q
+ ;
+ ;Need to find out how to get IP address
+ZIO N %,%1 S (%,%1)=$ZIO
+ I $ZV["VMS",%["_TNA" D
+ . S (%,%1)=$ZGETDVI($I,"TT_ACCPORNAM")
+ . S %=$S(%["Host:":$P($P(%,"Host: ",2)," ")_":"_$P(%,"Port: ",2),1:%) S:%[" " %=$TR(%," ")
+ I $ZV'["VMS" D
+ . S (%,%1)=$ZTRNLNM("REMOTEHOST") S:$L(%) %1="Host:"_% S:'$L(%) %=$ZIO
+ S IO("ZIO")=% S:(%1["Host:")&'$D(IO("IP")) IO("IP")=$P(%,":")
+ Q
+ ;
+TCPIP ;For TCP/IP devices
+ N %S
+ S %ZISTO=$G(%ZISTO,3)
+ S %A="IO:"_$S($E(%ZISOPAR)="(":"",1:"(")_%ZISOPAR_$S($E(%ZISOPAR,$L(%ZISOPAR))=")":"",1:")")_":%ZISTO:""SOCKET"""
+ ;U $P W !,"%A=",%A
+ O @%A I '$T S POP=1 Q  ;D O1 ;Do the open.
+ U IO:(WIDTH=512:NOWRAP:EXCEPT="G OPNERR^%ZIS4") S %S=$KEY
+ U $P ;W !,"$KEY=",%S
+ Q
+ ;
+SPOOL ;%ZDA=pointer to ^XMB(3.51, %ZFN=spool file name.
+ I $D(ZISDA) W:'$D(IOP) !?5,*7,"You may not Spool the printing of a Spool document" G N
+ I $D(DUZ)[0 W:'$D(IOP) !,"Must be a valid user." G N
+R S %ZY=-1 D NEWDOC^ZISPL1 G N:%ZY'>0 S %ZDA=+%ZY,%ZFN=$P(%ZY(0),U,2),IO("DOC")=$P(%ZY(0),U,1) G OK:$D(IO("Q"))
+ G:'%ZISB OK I '$P(%ZY,"^",3),%ZFN]"" D SPL3 G N:%ZFN']"",DOC
+ S %ZFN=IO_"SPOOL_no_"_%ZDA_".TMP" D SPL2 G:%ZFN']"" N S $P(^XMB(3.51,%ZDA,0),U,2)=%ZFN,^XMB(3.51,"C",%ZFN,%ZDA)=""
+DOC S IO=%ZFN,IO("SPOOL")=%ZDA,^XUTL("XQ",$J,"SPOOL")=%ZDA,IOF="#"
+ I $D(^%ZIS(1,%ZISIOS,1)),$P(^(1),"^",8),$O(^("SPL",0)) S ^XUTL("XQ",$J,"ADSPL")=%ZISIOS,ZISPLAD=%ZISIOS
+OK K %ZDA,%ZFN Q
+N K %ZDA,%ZFN,IO("DOC") S POP=1 Q
+SPL2 O %ZFN:(NEWVERSION:WORLD=RWD) G:$ZA<0 SPL4 S IO(1,%ZFN)="" Q
+SPL3 N X S X="SPL4^%ZIS4",@^%ZOSF("TRAP")
+ O %ZFN:READONLY:1 S:'$T ZISPLQ=1 G:$ZA<0!('$T) SPL4 S IO(1,%ZFN)="" Q
+SPL4 W:'$D(IOP)&'$D(ZTQUEUED) !?5,*7,"Couldn't open the spool file." S %ZFN="" Q
+CLOSE N %Z1 C:IO]"" IO K:IO]"" IO(1,IO) D FILE^ZISPL1 I %ZDA'>0 K ZISPLAD Q
+ S %ZFN=$P(%ZS,"^",2) D SPL3 Q:%ZFN']""  U %ZFN S %ZCR=$C(13),%Y="",X="SPLEOF^%ZIS4",@^%ZOSF("TRAP")
+ S %Z1=+$G(^XTV(8989.3,1,"SPL"))
+ F %=0:0 R %X#255:5 Q:$ZA<0  S %2=%X D CL2 G:%Z1<% SPLEX
+SPLEOF I $ZE'["ENDO" Q  ;Send error up
+SPLEX C %ZFN:(DELETE) K:%ZFN]"" IO(1,%ZFN) D CLOSE^ZISPL1 K %Y,%X,%1,%ZFN Q
+ ;
+CL2 S %=%+1 I %Z1<% S ^XMBS(3.519,XS,2,%,0)="*** INCOMPLETE REPORT  -- SPOOL DOCUMENT LINE LIMIT EXCEEDED ***",$P(^XMB(3.51,%ZDA,0),"^",11)=1 Q
+ I %2[$C(12) S ^XMBS(3.519,XS,2,%,0)="|TOP|" Q
+ S ^XMBS(3.519,XS,2,%,0)=%2 Q
+ ;
+HFS G HFS^%ZISF
+REWMT(IO,IOPAR) ;Rewind Magtape
+ S X="REWERR^%ZIS4",@^%ZOSF("TRAP")
+ U IO W *5
+ Q 1
+REWSDP(IO,IOPAR) ;Rewind SDP
+ G REW1
+REWHFS(IO,IOPAR) ;Rewind Host File.
+REW1 S X="REWERR^%ZIS4",@^%ZOSF("TRAP")
+ U IO:(REWIND)
+ Q 1
+REWERR ;Error encountered
+ Q 0
Index: WorldVistAEHR/trunk/r/KERNEL-XU-A4A7-USC-XG-XLF-XNOA-XPD-XQ-XVIR-ZI-ZOSF-ZOSV-ZT-ZU-%Z-XIP--XQAB--XUC--XUR--ZIN--ZTED/_ZIS6.m
===================================================================
--- WorldVistAEHR/trunk/r/KERNEL-XU-A4A7-USC-XG-XLF-XNOA-XPD-XQ-XVIR-ZI-ZOSF-ZOSV-ZT-ZU-%Z-XIP--XQAB--XUC--XUR--ZIN--ZTED/_ZIS6.m	(revision 613)
+++ WorldVistAEHR/trunk/r/KERNEL-XU-A4A7-USC-XG-XLF-XNOA-XPD-XQ-XVIR-ZI-ZOSF-ZOSV-ZT-ZU-%Z-XIP--XQAB--XUC--XUR--ZIN--ZTED/_ZIS6.m	(revision 623)
@@ -1,101 +1,88 @@
-%ZIS6	;SFISC/AC - DEVICE HANDLER -- RESOURCES ;1/24/08  16:09
-	;;8.0;KERNEL;**24,49,69,118,127,136,440**;JUL 10, 1995;Build 13
-	;Per VHA Directive 2004-038, this routine should not be modified
-	;Expect that IO is current device
-OXECUTE	;Open Execute
-	I $D(^%ZIS(2,%ZISIOST(0),2))=1 S %Y=^(2) D 2
-ANSBAK	;Answer Back
-	I $D(^%ZIS(2,%ZISIOST(0),102)) S %Y=^(102) D 2 E  S POP=1 D:'$D(IOP) SAY($C(7)_"[NOT ON LINE]") C:%ZISB IO K IO(1,IO) G QUIT
-	I $D(%ZISMTR) X ^%ZOSF("MAGTAPE") U IO W:$D(%MT("REW")) @%MT("REW") U IO(0) K %MT
-	G QUIT:'$D(IO("P"))
-	I $F(IO("P"),"B"),$D(^%ZIS(2,%ZISIOST(0),7)) S %Y=$P(^(7),"^",1) I %Y]"" W @%Y
-	S %Y=$F(IO("P"),"P") G QLTY:'%Y S %Y=+$E(IO("P"),%Y,99),%X=$S(%Y=16:12.1,%Y=10!(%Y=12):5,1:"") G QLTY:'%X
-	S %Y=$S($D(^%ZIS(2,%ZISIOST(0),%X)):$P(^(%X),"^",$S(%Y=12:2,1:1)),1:"")
-	I %Y]"" W @%Y
-QLTY	S %Y=$F(IO("P"),"Q") Q:'%Y  S %Y=+$E(IO("P"),%Y,99),%X=$S(%Y<0!(%Y>2):0,1:%Y+1)
-	I %X S %Y=$S($D(^%ZIS(2,%ZISIOST(0),12.2)):$P(^(12.2),"^",%X),1:"") I %Y]""  W @%Y
-QUIT	U:%IS'[0 IO(0)
-	Q
-2	Q:%Y=""  I %IS'[0,$D(^%ZIS(1,+%H,"TYPE")),^("TYPE")["TRM" D OH Q:POP
-	S %X=$T U IO D %Y^ZISX ;Q:'%X  U IO(0)
-	Q
-OH	Q:$S($G(IO(0))]"":$D(IO(1,IO(0))),1:0)
-	N X S X="OPNERR^%ZIS4",@^%ZOSF("TRAP")
-	O IO(0)::0 S IO(1,IO(0))="" Q  ;See that HOME DEVICE is open.
-	;
-SAY(%SAY)	;
-	Q:%IS[0  U IO(0) W %SAY U IO
-	Q
-RES1	;Allocate a resource slot, Release in %ZISC.
-	N A,L,X,%ZISD0
-	S %ZISD0=$O(^%ZISL(3.54,"B",IO,0))
-	I '%ZISD0 S %ZISD0=$$RADD(IO) ;New one
-	L +^%ZISL(3.54,%ZISD0,0):2 I '$T S POP=1 W:'$D(IOP) *7,"  [NOT Available]" G RESX
-RES2	S X=$P(^%ZISL(3.54,%ZISD0,0),"^",2)
-	I X<1 S POP=1 W:'$D(IOP) *7,"  [NOT Available]" G RESX
-	S X=$S(X>0:X-1,1:0),$P(^%ZISL(3.54,%ZISD0,0),"^",2)=X
-	;
-R1	;Grab a slot
-	S IO(1,IO)="RES",A=$G(^%ZISL(3.54,%ZISD0,1,0),"^3.542^^")
-	F L=1:1:%ZISRL I '$D(^%ZISL(3.54,%ZISD0,1,L,0)) Q
-	I '$T K IO(1,IO) G RES2 ;No free slots
-	S ^%ZISL(3.54,%ZISD0,1,L,0)=L_"^"_%ZISV_"^"_$J_"^"_$G(ZTSK)_"^"_$H,^%ZISL(3.54,"AJ",$J,%ZISD0,L)="",^%ZISL(3.54,%ZISD0,1,"B",L,L)=""
-	S $P(A,"^",3,4)=L_U_($P(A,U,4)+1),^%ZISL(3.54,%ZISD0,1,0)=A
-RESX	L -^%ZISL(3.54,%ZISD0,0) Q
-	;
-RADD(X)	;Add Resource
-	N %1,%2
-	S %1=$G(^%ZISL(3.54,0),"RESOURCE^3.54^^"),%2=$P(%1,U,3)
-	F %2=%2:1 Q:'$D(^%ZISL(3.54,%2,0))
-	S $P(^%ZISL(3.54,0),U,3,4)=%2_U_($P(%1,U,4)+1),^%ZISL(3.54,%2,0)=X_"^"_$G(%ZISRL,1),^%ZISL(3.54,"B",X,%2)=""
-	Q %2
-	;
-RESOK	;DEVOK check for RES devices, for all OS's.
-	N %ZISD0,%ZISD1
-	S Y=0,%ZISD0=$O(^%ZISL(3.54,"B",X,0))
-	I '%ZISD0 S Y=-1,%ZISD0=$O(^%ZIS(1,"C",X,0)) Q:'%ZISD0  Q:'$D(^%ZIS(1,+%ZISD0,0))  Q:$P(^(0),"^")'=X  Q:'$D(^("TYPE"))  Q:^("TYPE")'="RES"  S Y=0 Q
-	S X1=$G(^%ZISL(3.54,+%ZISD0,0))
-	I $P(X1,"^",2)&(X=$P(X1,"^")) S Y=0 Q
-	S Y=999 F %ZISD1=0:0 S %ZISD1=$O(^%ZISL(3.54,%ZISD0,1,%ZISD1)) Q:%ZISD1'>0  I $D(^(%ZISD1,0)) S Y=$P(^(0),"^",3) Q
-	Q
-	;
-Q	G Q^%ZIS3
-HG	;
-	Q
-SPL	;Spool type
-	N %E,%Z D MARGN^%ZIS3 W:'$D(IOP) ! D SPOOL^%ZIS4:%IS'["T"
-	G Q
-MT	D MARGN^%ZIS3,ASKPAR,AMTREW:'POP&'$D(IOP)&%ZISB W:'$D(IOP) ! D O^%ZIS4:'POP&(%ZISB&(%IS'["T")) ;Magtape type
-	G Q
-SDP	;Sequential disk processor type
-	D MARGN^%ZIS3,ASKPAR W:'$D(IOP) ! D O^%ZIS4:'POP&(%ZISB&(%IS'["T"))
-	G Q
-HFS	;Host File Server type
-	D MARGN^%ZIS3,HFS^%ZIS4 W:'$D(IOP) ! D O^%ZIS4:'POP&(%ZISB&(%IS'["T"))
-	G Q
-RES	;Resources
-	G Q:%IS["T" N X,X1 I %IS'["R"!'$D(IOP) S POP=1 W:'$D(IOP) *7,"  [NOT AVAILABLE]" Q
-	G Q:$D(IO(1,IO)) I %IS["T" S X=IO,X1="RES" D DEVOK^%ZIS3 S:Y POP=1 G Q:POP
-	D:%ZISB RES1 G Q
-CHAN	;Network Channel type devices -- DecNet or TCP/IP devices.
-	I IO="SYS$NET",$I="SYS$INPUT:;" S IO(0)=IO U IO ;DECNET Server Device
-	D MARGN^%ZIS3:'POP,ASKPAR:'POP W:'$D(IOP) ! D O^%ZIS4:'POP&(%ZISB&(%IS'["T"))
-	G Q
-IMPC	;Imaging Work Station
-BAR	;Bar Code
-OTH	;Other Device type
-	D MARGN^%ZIS3:'POP,ASKPAR:'POP W:'$D(IOP) ! D O^%ZIS4:'POP&(%ZISB&(%IS'["T"))
-	G Q
-	;
-ASKPAR	;Ask Parameters
-	G SETPAR^%ZIS3:$D(IOP),SETPAR^%ZIS3:'$P(^%ZIS(1,%E,0),"^",4) W "  ADDRESS/PARAMETERS: " W:%ZISOPAR]"" %ZISOPAR_"// " D SBR^%ZIS1 D MSG1:%X="?" G ASKPAR:%X="?" S:%X]"" %ZISOPAR=%X I $D(DTOUT)!$D(DUOUT) S POP=1
-	I POP,%ZISB&(%ZTYPE["TRM") C IO K IO(1,IO) Q
-	Q:POP  G SETPAR^%ZIS3
-	;
-AMTREW	;Mag Tape Rewind
-	I %ZISB,%ZTYPE="MT",'$D(IOP) W "  REWIND" S %=2,U="^",%ZISDTIM=60 D YN^%ZIS1 K %ZISDTIM G AMTREW:%=0 I %=-1 S POP=1 Q
-	S:%=1 %ZISMTR=1
-	Q
-MSG1	W !?5,"Enter the desired parameters needed to open the selected device.",!?25
-	Q
-	;
+%ZIS6 ;SFISC/AC - DEVICE HANDLER -- RESOURCES ;02/04/2000  08:14
+ ;;8.0;KERNEL;**24,49,69,118,127,136**;JUL 10, 1995
+ ;Expect that IO is current device
+OXECUTE I $D(^%ZIS(2,%ZISIOST(0),2))=1 S %Y=^(2) D 2
+ANSBAK I $D(^%ZIS(2,%ZISIOST(0),102)) S %Y=^(102) D 2 E  S POP=1 D:'$D(IOP) SAY($C(7)_"[NOT ON LINE]") C:%ZISB IO K IO(1,IO) G QUIT
+ I $D(%ZISMTR) X ^%ZOSF("MAGTAPE") U IO W:$D(%MT("REW")) @%MT("REW") U IO(0) K %MT
+ G QUIT:'$D(IO("P"))
+ I $F(IO("P"),"B"),$D(^%ZIS(2,%ZISIOST(0),7)) S %Y=$P(^(7),"^",1) I %Y]"" W @%Y
+ S %Y=$F(IO("P"),"P") G QLTY:'%Y S %Y=+$E(IO("P"),%Y,99),%X=$S(%Y=16:12.1,%Y=10!(%Y=12):5,1:"") G QLTY:'%X
+ S %Y=$S($D(^%ZIS(2,%ZISIOST(0),%X)):$P(^(%X),"^",$S(%Y=12:2,1:1)),1:"")
+ I %Y]"" W @%Y
+QLTY S %Y=$F(IO("P"),"Q") Q:'%Y  S %Y=+$E(IO("P"),%Y,99),%X=$S(%Y<0!(%Y>2):0,1:%Y+1)
+ I %X S %Y=$S($D(^%ZIS(2,%ZISIOST(0),12.2)):$P(^(12.2),"^",%X),1:"") I %Y]""  W @%Y
+QUIT U:%IS'[0 IO(0)
+ Q
+2 Q:%Y=""  I %IS'[0,$D(^%ZIS(1,+%H,"TYPE")),^("TYPE")["TRM" D OH Q:POP
+ S %X=$T U IO D %Y^ZISX ;Q:'%X  U IO(0)
+ Q
+OH Q:$S($G(IO(0))]"":$D(IO(1,IO(0))),1:0)
+ N X S X="OPNERR^%ZIS4",@^%ZOSF("TRAP")
+ O IO(0)::0 S IO(1,IO(0))="" Q  ;See that HOME DEVICE is open.
+ ;
+SAY(%SAY) ;
+ Q:%IS[0  U IO(0) W %SAY U IO
+ Q
+RES1 ;Allocate a resource slot, Release in %ZISC.
+ N A,L,X,%ZISD0
+ S %ZISD0=$O(^%ZISL(3.54,"B",IO,0))
+ I '%ZISD0 S %ZISD0=$$RADD(IO) ;New one
+ L +^%ZISL(3.54,%ZISD0,0):2 I '$T S POP=1 W:'$D(IOP) *7,"  [NOT Available]" G RESX
+RES2 S X=$P(^%ZISL(3.54,%ZISD0,0),"^",2)
+ I X<1 S POP=1 W:'$D(IOP) *7,"  [NOT Available]" G RESX
+ S X=$S(X>0:X-1,1:0),$P(^%ZISL(3.54,%ZISD0,0),"^",2)=X
+ ;
+R1 ;Grab a slot
+ S IO(1,IO)="RES",A=$G(^%ZISL(3.54,%ZISD0,1,0),"^3.542^^")
+ F L=1:1:%ZISRL I '$D(^%ZISL(3.54,%ZISD0,1,L,0)) Q
+ I '$T K IO(1,IO) G RES2 ;No free slots
+ S ^%ZISL(3.54,%ZISD0,1,L,0)=L_"^"_%ZISV_"^"_$J_"^"_$G(ZTSK)_"^"_$H,^%ZISL(3.54,"AJ",$J,%ZISD0,L)="",^%ZISL(3.54,%ZISD0,1,"B",L,L)=""
+ S $P(A,"^",3,4)=L_U_($P(A,U,4)+1),^%ZISL(3.54,%ZISD0,1,0)=A
+RESX L -^%ZISL(3.54,%ZISD0,0) Q
+ ;
+RADD(X) ;Add Resource
+ N %1,%2
+ S %1=$G(^%ZISL(3.54,0),"RESOURCE^3.54^^"),%2=$P(%1,U,3)
+ F %2=%2:1 Q:'$D(^%ZISL(3.54,%2,0))
+ S $P(^%ZISL(3.54,0),U,3,4)=%2_U_($P(%1,U,4)+1),^%ZISL(3.54,%2,0)=X_"^"_$G(%ZISRL,1),^%ZISL(3.54,"B",X,%2)=""
+ Q %2
+ ;
+RESOK ;DEVOK check for RES devices, for all OS's.
+ N %ZISD0,%ZISD1
+ S Y=0,%ZISD0=$O(^%ZISL(3.54,"B",X,0))
+ I '%ZISD0 S Y=-1,%ZISD0=$O(^%ZIS(1,"C",X,0)) Q:'%ZISD0  Q:'$D(^%ZIS(1,+%ZISD0,0))  Q:$P(^(0),"^")'=X  Q:'$D(^("TYPE"))  Q:^("TYPE")'="RES"  S Y=0 Q
+ S X1=$G(^%ZISL(3.54,+%ZISD0,0))
+ I $P(X1,"^",2)&(X=$P(X1,"^")) S Y=0 Q
+ S Y=999 F %ZISD1=0:0 S %ZISD1=$O(^%ZISL(3.54,%ZISD0,1,%ZISD1)) Q:%ZISD1'>0  I $D(^(%ZISD1,0)) S Y=$P(^(0),"^",3) Q
+ Q
+ ;
+Q G Q^%ZIS3
+HG ;
+ Q
+SPL N %E,%Z D MARGN^%ZIS3 W:'$D(IOP) ! D SPOOL^%ZIS4:%IS'["T" ;Spool type
+ G Q
+MT D MARGN^%ZIS3,ASKPAR,AMTREW:'POP&'$D(IOP)&%ZISB W:'$D(IOP) ! D O^%ZIS4:'POP&(%ZISB&(%IS'["T")) ;Magtape type
+ G Q
+SDP D MARGN^%ZIS3,ASKPAR W:'$D(IOP) ! D O^%ZIS4:'POP&(%ZISB&(%IS'["T")) ;Sequential disk processor type
+ G Q
+HFS D MARGN^%ZIS3,HFS^%ZIS4 W:'$D(IOP) ! D O^%ZIS4:'POP&(%ZISB&(%IS'["T")) ;Host File Server type
+ G Q
+RES G Q:%IS["T" N X,X1 I %IS'["R"!'$D(IOP) S POP=1 W:'$D(IOP) *7,"  [NOT AVAILABLE]" Q  ;Resources
+ G Q:$D(IO(1,IO)) I %IS["T" S X=IO,X1="RES" D DEVOK^%ZIS3 S:Y POP=1 G Q:POP
+ D:%ZISB RES1 G Q
+CHAN ;Network Channel type devices -- DecNet or TCP/IP devices.
+ I IO="SYS$NET",$I="SYS$INPUT:;" S IO(0)=IO U IO ;DECNET Server Device
+ D MARGN^%ZIS3:'POP,ASKPAR:'POP W:'$D(IOP) ! D O^%ZIS4:'POP&(%ZISB&(%IS'["T"))
+ G Q
+IMPC ;Imaging Work Station
+BAR ;Bar Code
+OTH D MARGN^%ZIS3:'POP,ASKPAR:'POP W:'$D(IOP) ! D O^%ZIS4:'POP&(%ZISB&(%IS'["T")) ;Other Device type
+ G Q
+ ;
+ASKPAR G SETPAR^%ZIS3:$D(IOP),SETPAR^%ZIS3:'$P(^%ZIS(1,%E,0),"^",4) W "  ADDRESS/PARAMETERS: " W:%ZISOPAR]"" %ZISOPAR_"// " D SBR^%ZIS1 D MSG1:%X="?" G ASKPAR:%X="?" S:%X]"" %ZISOPAR=%X I $D(DTOUT)!$D(DUOUT) S POP=1
+ I POP,%ZISB&(%ZTYPE["TRM") C IO K IO(1,IO) Q
+ Q:POP  G SETPAR^%ZIS3
+AMTREW I %ZISB,%ZTYPE="MT",'$D(IOP) W "  REWIND" S %=2,U="^",%ZISDTIM=60 D YN^%ZIS1 K %ZISDTIM G AMTREW:%=0 I %=-1 S POP=1 Q
+ S:%=1 %ZISMTR=1 Q
+MSG1 W !?5,"Enter the desired parameters needed to open the selected device.",!?25 Q
+ ;
